disp('Creating Gaussian data...');
noise_var = 0.01;
n = 256^2;
f = Bowl(sqrt(n));
f = f((1:128)+100,(1:128)+40);
n = prod(size(f));
%f = double(imread('testImage.bmp'));
x = f + sqrt(noise_var)*randn(sqrt(n));

pen = 2*noise_var*((1)*log(n));
pen_w = 2*noise_var*((4/3)*log(n));
smallestBoxSidelength = 2^floor(log2(sqrt(n^(1/3))));
numWedges = n^(2/3);

disp('Generating Haar estimate (for comparison)...');
haarEst = haarApprox(x,pen,1);

disp('Generating coarse-to-fine estimate...');
[refinedEst, previewEst, previewPartition, corners, ...
    shimmeyPreviewEst, shimmeyPreviewPartition] = ...
  CTFPlateletApprox(x,smallestBoxSidelength,'Gaussian',pen,pen_w,numWedges);

MSE.obs = (sum(sum((f-x).^2) ))/(sum(sum(f.^2)));
MSE.haar = (sum(sum((f-haarEst).^2) ))/(sum(sum(f.^2)));
MSE.preview = (sum(sum((f-previewEst).^2) ))/(sum(sum(f.^2)));
MSE.refined = (sum(sum((f-refinedEst).^2) ))/(sum(sum(f.^2)));

MSE

figure(1)
bimagesc(x,[min(f(:))*.8,max(f(:))*1.2]);
axis image;
colormap(gray(256));
title(['Observations, MSE = ' num2str(MSE.obs, '%0.4g')])

figure(2)
bimagesc(haarEst,[min(f(:))*.8,max(f(:))*1.2]);
axis image;
colormap(gray(256));
title(['Haar Estimate, MSE = ' num2str(MSE.haar, '%0.4g')])

figure(3)
bimagesc(previewEst,[min(f(:))*.8,max(f(:))*1.2]);
axis image;
colormap(gray(256));
title(['Preview Estimate, MSE = ' num2str(MSE.preview, '%0.4g')])

figure(4)
bimagesc(refinedEst,[min(f(:))*.8,max(f(:))*1.2]);
axis image;
colormap(gray(256));
title(['Coarse-to-Fine Estimate, MSE = ' num2str(MSE.refined, '%0.4g')])

